

#include "gpio.h"


void system_gpio_init(void)
{
  unsigned int tmp=0;

  set_bit(RCC->AHB2ENR, 0);  /* enable the clock for the GPIOA peripheral */
  _NOP();
  _NOP();
  _NOP();

  set_bit(RCC->AHB2ENR, 1);  /* enable the clock for the GPIOB peripheral */
  _NOP();
  _NOP();
  _NOP();

  set_bit(RCC->AHB2ENR, 2);  /* enable the clock for the GPIOC peripheral */
  _NOP();
  _NOP();
  _NOP();

  /*configure GPIO pin : LD2_Pin */
  /*configure GPIO PA5 */
  tmp = GPIOA->MODER;    /* get mode */
  set_bit(tmp, 10);      /* set as output */
  clear_bit(tmp, 11);
  GPIOA->MODER = tmp;    /* set mode */

  tmp = GPIOA->OTYPER;   /* get output type */
  clear_bit(tmp, 5);     /* pushpull */
  GPIOA->OTYPER = tmp;   /* set output type */

  tmp = GPIOA->OSPEEDR;  /* get speed */
  clear_bit(tmp, 10);    /* low speed */
  clear_bit(tmp, 11);
  GPIOA->OSPEEDR = tmp;  /* set speed */

  tmp = GPIOA->PUPDR;    /* get pull-up/down */
  clear_bit(tmp, 10);    /* no pull-up/down */
  clear_bit(tmp, 11);
  GPIOA->PUPDR = tmp;    /* set pull-up/down */

  /*configure GPIO PA8 for MCO */
  tmp = GPIOA->MODER;    /* get mode */
  clear_bit(tmp, 16);    /* set as alternate function */
  set_bit(tmp, 17);
  GPIOA->MODER = tmp;    /* set mode */

  tmp = GPIOA->OTYPER;   /* get output type */
  clear_bit(tmp, 8);     /* pushpull */
  GPIOA->OTYPER = tmp;   /* set output type */

  tmp = GPIOA->OSPEEDR;  /* get speed */
  clear_bit(tmp, 16);    /* low speed */
  clear_bit(tmp, 17);
//   set_bit(tmp, 16);    /* high speed */
//   set_bit(tmp, 17);
  GPIOA->OSPEEDR = tmp;  /* set speed */

  tmp = GPIOA->PUPDR;    /* get pull-up/down */
  clear_bit(tmp, 16);    /* no pull-up/down */
  clear_bit(tmp, 17);
  GPIOA->PUPDR = tmp;    /* set pull-up/down */

  tmp = GPIOA->AFR[1];    /* get alternate function register high */
  clear_bit(tmp, 0);
  clear_bit(tmp, 1);      /* set to AF0 */
  clear_bit(tmp, 2);
  clear_bit(tmp, 3);
  GPIOA->AFR[1] = tmp;    /* set alternate function register high */
}




