/*
 ******************************************************************************
 *
 * file:          main.c
 * author:
 * email:
 * date:
 *
 * last revision:
 *
 * target:        STM32L452RET6 (no external SMPS) package: LQFP64  -40 to 85 degr.C (105 degr.C junction) integrated LDO
 * max sysclock:  80MHz
 *
 ******************************************************************************
 */

/*
 * pin  gpio   function     direction/function
 * -------------------------------------------
 * 58   PB6    USART1_TX       alt        RS232
 * 59   PB7    USART1_RX       alt        RS232
 *
 * 44   PA11    USB_DM         alt        USB
 * 45   PA12    USB_DP         alt        USB
 *
 ********************************************************************
 *
 */


#include "stm32l4xx.h"

#include "global.h"
#include "delay.h"
#include "utils.h"
#include "clock.h"
#include "gpio.h"
#include "rs232.h"





int main(void)
{
  system_clock_config();

  system_gpio_init();

  UART1_init(139);  /* 115200 */

  UART1_cprintf("\nBooting...\n");

  UART1_cprintf("Entering main loop\n");

/************************************** START OF MAIN LOOP *************************************/
  while(1)
  {

  }
}
/************************************** END OF MAIN LOOP *************************************/



void sys_tick_handler(void)  /* function name must be the same as used in interrupt vector table in file startup_stm32.s! */
{
  static unsigned int i=0;

  if(++i == 30)  /* blink green LED */
  {
    if(test_bit(GPIOA->ODR, 5))
    {
      GPIOA->BRR = 1 << 5;  /* clear GPIO pin */
    }
    else
    {
      GPIOA->BSRR = 1 << 5;  /* set GPIO pin */
    }

    i = 0;
  }
}




























